"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.serializeStyles = void 0;
function serializeStyles(styleRecord) {
    const media = {};
    const styles = Object.fromEntries(Object.entries(styleRecord).flatMap(([key, value]) => {
        return value.map((style) => {
            var _a;
            let newKey = key;
            if ("atRules" in style) {
                const { atRules, ...rest } = style;
                (_a = media[key]) !== null && _a !== void 0 ? _a : (media[key] = []);
                newKey = `${key}.${media[key].length}`;
                media[key].push(atRules);
                style = rest;
            }
            return [newKey, style];
        });
    }));
    return { styles, media };
}
exports.serializeStyles = serializeStyles;
